const SM_CONNECTION_TTL = 1; //minutes

var smashinoy_connection = {
	handlers : [],
	interval : 0,
	counter : 0,
	ttl : SM_CONNECTION_TTL*60000,
	referrer : null,

	prepareURL : function(urlArray) {
		return "http://comet1.smashinoy.ru/";
	},

	makeRequest : function (email, urlArray, action, contents, ignoreResponse) {
		var content = "";
		var request = new XMLHttpRequest();
		var url = this.prepareURL(urlArray);

		request.open("GET", url, true);

		this.referrer = null;
		request.send(content);

		request.onreadystatechange = function() {
			if (request.readyState==4) {
				action(request, email);
			}
		}

		if (!this.interval) {
			this.interval = window.setInterval(function(){smashinoy_connection.cleanup();}, this.ttl);
		}
	},

	cleanup : function(shutdown) {
		var time = (new Date()).getTime();
		for (var i in this.handlers) {
			if (shutdown || time-this.handlers[i].created >= this.ttl) {
				this.handlers[i].unregister();
				delete this.handlers[i];
			}
		}
		if (this.handlers.length==0 && this.interval) {
			window.clearInterval(this.interval);
			this.interval = 0;
		}
	}
}
