	Multiplexor = function(identifier) {
		// Maximum bounce count.
		var MAX_BOUNCES = 2;
		// Reconnect delay.
		var WAIT_RECONNECT_DELAY = 1000;
		var WAIT_URI = SMASHINOY_MPLEX_URL;
		var WAIT_TIMEOUT = 20;
		var DEBUG = 0;
		
		// Closure variable.
		var th = this;
		// Count of sequential bounces.
		var bounceCount = 0;
		// Previous request time.
		var prevReqTime = null;
		// Previously used xmlhttp.
		var lastXmlhttp = null;
		
		// Return the parent's document.
		var doc = function() {
			return top.document;
		}
		
		// Creates the new XMLHttpRequest object.
		var getXmlHttp = function() {
			var xmlhttp;
			if (typeof XMLHttpRequest != 'undefined') {
				xmlhttp = new XMLHttpRequest();
			}
			if (!xmlhttp) try {
				xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
			} catch (e) {
			}
			if (!xmlhttp) try {
				xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e) {
			}
			return xmlhttp;
		}
		
		
		
		// Process the response data.
		var processResponse = function(response) {
			if ( ! response ) return;
			smashinoy_main.MultiplexorProcessData(response);
        }
		
		
		
		// Loop function.
		var loopFunc = function() {

			var url = WAIT_URI + '?identifier=' + identifier;
			//alert(url);
			
			
			var xmlhttp = getXmlHttp();
			if (!xmlhttp) return;

			xmlhttp.open('GET', url, true);
			
			xmlhttp.onreadystatechange = function() {
				
				if (xmlhttp.readyState != 4) return;
				lastXmlhttp = null;
				var nextQueryDelay = WAIT_RECONNECT_DELAY;
				
				// Run the query.
				var result = null;

				// Safary bug: responseText somtimes contain headers+body, not only body!
				var text = xmlhttp.responseText;
				//if (text) text = text.replace(/^[^{]*/, '');

				try {
					//eval('result = ' + text + ';');
					
					var result = JSON.parse(text);
					
					bounceCount = 0;
				} catch (e) {
					var t = new Date().getTime();
					if (t - prevReqTime < WAIT_TIMEOUT * 1000) {
						// This is an unexpected disconnect (bounce).
						bounceCount++;
					}
					prevReqTime = t;
				}
				
				// Calculate next query delay.
				if (bounceCount > MAX_BOUNCES) {
					// Progressive delay.
					var progressive = bounceCount - MAX_BOUNCES + 2;
					nextQueryDelay = 1000 + 500 * progressive * progressive;
				}
				
				// Process the response.
				processResponse(result);
				
				
				// Reconnect.
				setTimeout(function () {loopFunc();}, nextQueryDelay);
			}
			prevReqTime = new Date().getTime();
			xmlhttp.send(null);
			lastXmlhttp = xmlhttp;
			
		}
	
	
	
		// Runs the polling process.
		this.run = function() {
			setTimeout(function () {loopFunc();}, 1000);
			//setTimeout(loopFunc, 100);
			//loopFunc();
		}
	}