function smashinoy_observer() {
	this.created = (new Date()).getTime();
	this.topics = [];
	this.observerService = Components.classes["@mozilla.org/observer-service;1"]
				.getService(Components.interfaces.nsIObserverService);
}

smashinoy_observer.prototype = {
	register : function(topic, callback) {
		this.observerService.addObserver(this, topic, false);
		this.topics[topic] = callback;
	},

	unregister : function() {
		for (var i in this.topics) {
			this.observerService.removeObserver(this, i);
		}
	},

	observe : function(subject, topic, data) {
		if (this.topics[topic]) {
			this.topics[topic](subject, data);
		}
	}
}
